#include <alloc.h>
#include <dos.h>
#include <float.h>
#include <fcntl.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "wireframe.h"

extern int window_width, window_height;
extern double offsetx, offsety;

static FILE *TargaFile;

typedef unsigned char DacPalette[256][3];
DacPalette Palette;

struct viewporttype actual_view;
double offsetx, offsety;
int window_width, window_height;
int g_driver, g_mode, g_error;

/* Setvgapalette sets the entire 256 color palette */
/* PalBuf contains RGB values for all 256 colors   */
/* R,G,B values range from 0 to 63                 */
void
setvgapalette(DacPalette *PalBuf)
{
  struct REGPACK reg;

  reg.r_ax = 0x1012;
  reg.r_bx = 0;
  reg.r_cx = 256;
  reg.r_es = FP_SEG(PalBuf);
  reg.r_dx = FP_OFF(PalBuf);
  intr(0x10,&reg);
}

/* 332 pallette */
void
pallete_init()          /* Fill VGA 256 color palette with colors! */
{
   int i, j, index;
   int r, g, b;
   int pts[8];

   for (r=0;r<8;r++)
      for (g=0;g<8;g++)
         for (b=0;b<4;b++) {
            index = (r * 32 + g * 4 + b);
            Palette[index][0] = (int)(r * 9); /* 64.0 / 7.0); */
            Palette[index][1] = (int)(g * 9); /* 64.0 / 7.0); */
            Palette[index][2] = (int)(b * 21); /* 64.0 / 3.0); */
            }

   setvgapalette(&Palette);
   /*
   for (i=0;i<16;i++) for (j=0;j<16;j++) {
      setcolor(i * 16 + j);
      setfillstyle(SOLID_FILL, i * 16 + j);
      pts[0] = 16 * i;     pts[1] = 16 * j;
      pts[2] = 16 * (i+1); pts[3] = 16 * j;
      pts[4] = 16 * (i+1); pts[5] = 16 * (j+1);
      pts[6] = 16 * i;     pts[7] = 16 * (j+1);
      fillpoly(4, &pts[0]);
      }
   getch();
   */
   return;
}

/* plot a single RGB pixel */

/* Decode 332 */
int
get_indexed_color(VECTOR color)
{
   int icolor, Red, Green, Blue;

   Red   = (int)(7.0 * color.x);
   Green = (int)(7.0 * color.y);
   Blue  = (int)(3.0 * color.z);
   icolor = (int)(Red * 32 + Green * 4 + Blue);
   return icolor;
}

int huge
DetectVGA()
{
  int Vid;
  printf("Video modes:\n");
  printf("  0) 320x200x256\n");
  printf("  1) 640x400x256\n");
  printf("  2) 640x480x256\n");
  printf("  3) 800x600x256\n");
  printf("  4) 1024x768x256\n");
  scanf("%d",&Vid);
  return Vid;
}

/* Initialize graphics mode. */
void
initialize_graphics()
{
   int xasp, yasp;
   char ch, txy[80];
   g_driver = DETECT;

   installuserdriver("SVGA256", DetectVGA);
   initgraph(&g_driver,&g_mode,"");
   setcolor(15);
   getviewsettings(&actual_view);
   setviewport(actual_view.left, actual_view.right,
               actual_view.top, actual_view.bottom, 1);
   pallete_init();
   offsetx = (double)(actual_view.right - actual_view.left) / 2.0;
   offsety = (double)(actual_view.bottom - actual_view.top) / 2.0;
   window_width = (actual_view.right - actual_view.left) + 1;
   window_height = (actual_view.bottom - actual_view.top) + 1;
   /* printf("Screen: %dx%d\n", window_width, window_height); */
}

void
reset_pallette()
{
   setvgapalette(&Palette);
}

void
TargaOpen(char *filename, int x, int y)
{
   FILE *file;
   unsigned char tgaheader[18];
   if ((file = fopen(filename, "wb")) == NULL) {
      printf("Failed to open Targa file: %s\n", filename);
      exit(1);
      }
   memset(tgaheader, 0, 18);
   tgaheader[2] = 2;
   tgaheader[12] = x & 0xFF;
   tgaheader[13] = (x >> 8) & 0xFF;
   tgaheader[14] = y & 0xFF;
   tgaheader[15] = (y >> 8) & 0xFF;
   tgaheader[16] = 24;
   tgaheader[17] = 0x20;
   fwrite(tgaheader, 18, 1, file);
   TargaFile = file;
}

void
TargaWrite()
{
   int i, offset;
   extern unsigned long Total_Map_Buffers, Total_Elements_Per_Buffer;
   extern Screen_Map_Type Screen_Map[64];
   for (i=0;i<Total_Map_Buffers;i++)
      for (offset=0;offset<Total_Elements_Per_Buffer;offset++) {
         fputc(Screen_Map[i][offset].blue, TargaFile);
         fputc(Screen_Map[i][offset].green, TargaFile);
         fputc(Screen_Map[i][offset].red, TargaFile);
         }
}

void
IndexedWrite()
{
   unsigned index;
   int i, j;
   for (i=0;i<window_height;i++)
      for (j=0;j<window_width;j++) {
         index = getpixel(j, i);
         fputc(4 * Palette[index][2], TargaFile);
         fputc(4 * Palette[index][1], TargaFile);
         fputc(4 * Palette[index][0], TargaFile);
	 }
}

void
TargaClose()
{
   fclose(TargaFile);
}
